/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package visuAnalec.chaines;

import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.util.*;
import javax.swing.*;
import visuAnalec.chaines.ModeleChaines.*;
import visuAnalec.util.GMessages.*;
import visuAnalec.util.GVisu.*;

/**
 *
 * @author Bernard
 */
public class GChaines extends JPanel {
  final static Font FONTE_ID = Font.decode("Arial bold 10");
  final static int RAYON_DISQUES = 6;
  final static int MARGE_DISQUES = 2;
  final static int LARGEUR_INTER_CHAINONS = 10;
  final static int POSITION_Y_CHAINONS = 60;
  final static int POSITION_Y_SEGMENT = 40;
  final static String SYMBOLE_SEGMENT = "§";
//    final static int hauteurinfLien = 25;
//    final static int deltahauteurLien = 5;
//    final static int deltasupArcs = 95;
//    final static int hauteurinfArcs = 5;
  final static int HAUTEUR_PANNEAU = 120;
  final static String PAS_DE_NUMERO = "~";

  static class GChainon extends JButton {
    VisuChaines visu;
    Chainon chainon;
    public GChainon(Chainon ch, VisuChaines vis) {
      super();
      this.visu = vis;
      this.chainon = ch;
      Icon d = new DisqueCouleurIcone(Color.WHITE, RAYON_DISQUES, MARGE_DISQUES);
      setAction(new GAction(null, d) {
        public void executer() {
          visu.afficherOccurrences(chainon.unite, chainon.chaine);
        }
      });
      setSize(2*(RAYON_DISQUES + MARGE_DISQUES), 2*(RAYON_DISQUES + MARGE_DISQUES));
      setBorderPainted(false);
      String t2 = "<html><div style=\"font-size:11pt\"><span style=\"font-style:italic\">" + chainon.texte +
              "</span><p>" + chainon.idChaine + "<p>" + chainon.nbEltsChaine + " occurences </div>";
      setToolTipText(t2);
      setBackground(Color.WHITE);
      setFocusPainted(false);
    }
    @Override
    public JToolTip createToolTip() {
      JToolTip jt = new JToolTip();
      jt.setBackground(Color.WHITE);
      return jt;
    }
    void changerCouleur(Color couleur) {
      setIcon(new DisqueCouleurIcone(couleur, RAYON_DISQUES, MARGE_DISQUES));
    }
  }

  static class GNoChainon extends JLabel {
    public GNoChainon(int noChaine) {
      super(noChaine == 0 ? PAS_DE_NUMERO : Integer.toString(noChaine));
      setFont(FONTE_ID);
      setSize(getPreferredSize());
    }
    void localiser(Point chainonPosition, Dimension chainonTaille) {
      int x = chainonPosition.x + chainonTaille.width / 2 - getSize().width / 2;
      int y = POSITION_Y_CHAINONS  - getSize().height;
      setLocation(x, y);
    }
  }

  static class GSegment extends JLabel {
    int xmin, xmax;
    int no;
    GSegment(int xmin, int xmax, int no) {
      super(SYMBOLE_SEGMENT + Integer.toString(no));
      setFont(FONTE_ID);
      this.xmin = xmin;
      this.xmax = xmax;
      setSize(getPreferredSize());
    }
    void localiser() {
      setLocation((xmin + xmax) / 2 - getSize().width / 2, POSITION_Y_SEGMENT - getSize().height);
    }
    void dessinerTraits(Graphics graphics) {
      Graphics2D g = (Graphics2D) graphics;
      g.setColor(Color.BLACK);
      Point p0 = new Point(xmin, POSITION_Y_CHAINONS);
      Point p1 = new Point(xmin, POSITION_Y_SEGMENT);
      Point p2 = new Point(xmax, POSITION_Y_SEGMENT);
      Point p3 = new Point(xmax, POSITION_Y_CHAINONS);
      g.draw(new Line2D.Float(p0, p1));
      g.draw(new Line2D.Float(p1, p2));
      g.draw(new Line2D.Float(p2, p3));
    }
  }
  /*
   * Champs de la classeGChaines
   */
  VisuChaines visu;
  GChainon[] gChainons;
  ArrayList<GSegment> gSegments = new ArrayList<GSegment>();
  int largeur;
  GChaines(VisuChaines vc) {
    super((LayoutManager) null);
    setBackground(Color.WHITE);
    this.visu = vc;
    addMouseListener(new MouseAdapter() {
      @Override
      public void mouseClicked(MouseEvent e) {
        visu.traiterAffTexteClicVide();
      }
     });
  }
  void afficher(Chainon[] chainons, int[] noSegments) {
    removeAll();
    gChainons = new GChainon[chainons.length];
    largeur = LARGEUR_INTER_CHAINONS;
    GNoChainon gNoChainon;
    int noSegCourant = noSegments[0];
    int xminSeg = LARGEUR_INTER_CHAINONS / 2 + 2;
    GSegment gseg;
    int xmaxSeg;
    for (int i = 0; i < chainons.length; i++) {
      gChainons[i] = new GChainon(chainons[i], visu);
      add(gChainons[i]);
      gChainons[i].setLocation(largeur, POSITION_Y_CHAINONS);
      add(gNoChainon = new GNoChainon(chainons[i].noChaine));
      gNoChainon.localiser(gChainons[i].getLocation(), gChainons[i].getSize());
      if (noSegments[i] > noSegCourant) {
        xmaxSeg = largeur - LARGEUR_INTER_CHAINONS / 2 - 2;
        add(gseg = new GSegment(xminSeg, xmaxSeg, noSegCourant));
        gseg.localiser();
        gSegments.add(gseg);
        xminSeg = xmaxSeg + 4;
        noSegCourant = noSegments[i];
      }
      largeur += gChainons[i].getWidth() + LARGEUR_INTER_CHAINONS;
    }
    xmaxSeg = largeur + LARGEUR_INTER_CHAINONS / 2 - 2;
    add(gseg = new GSegment(xminSeg, xmaxSeg, noSegCourant));
    gseg.localiser();
    gSegments.add(gseg);
    setPreferredSize(new Dimension(largeur, HAUTEUR_PANNEAU));
  }
  void changerCouleurs(Color[] couleurs) {
    for (int i = 0; i < gChainons.length; i++) {
      gChainons[i].changerCouleur(couleurs[i]);
    }
    revalidate();
    repaint();
  }
  void effacerTout() {
    removeAll();
    gChainons = new GChainon[0];
    gSegments.clear();
    repaint();
  }
  void effacer(Graphics graphics) {
    graphics.setColor(Color.WHITE);
    graphics.fillRect(0, 0, getWidth(), getHeight());
  }
  @Override
  protected void paintComponent(Graphics graphics) {
    effacer(graphics);
    for (GSegment gs : gSegments) gs.dessinerTraits(graphics);
  }
}
 
