/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package visuAnalec.fichiers;

import java.io.*;
import javax.swing.*;
import visuAnalec.donnees.*;
import visuAnalec.util.*;
import visuAnalec.util.Fichiers.*;
import visuAnalec.vue.*;

/**
 *
 * @author Bernard
 */
public abstract class FichiersJava {
  public static void ouvrirCorpusVue(Corpus corpus, Vue vue, String nomfichier) {
    File fichierCorpus;
    if (nomfichier.isEmpty()) {
      if ((fichierCorpus = Fichiers.choisirFichier(Commande.OUVRIR,
              "Choix du corpus", Fichiers.Type.CORPUS)) == null) return;
    } else {
      if ((fichierCorpus = Fichiers.trouverFichier(Fichiers.Type.CORPUS, nomfichier)) == null) {
        JOptionPane.showMessageDialog(null, "Fichier " + nomfichier + " inexistant dans le répertoire " +
                Fichiers.getRepertoireCourant(Fichiers.Type.CORPUS).getPath(), "Erreur de lecture de fichier",
                JOptionPane.ERROR_MESSAGE);
        return;
      }
    }
    ObjectInputStream ois = null;
    try {
      ois = new ObjectInputStream(new FileInputStream(fichierCorpus));
      corpus.lireJava(ois);
    } catch (ClassNotFoundException e) {
      JOptionPane.showMessageDialog(null, "Impossible de lire le corpus " + fichierCorpus.getName() +
              " : versions d'Analec incompatibles ",
              "Erreur d'ouverture de fichier .ec", JOptionPane.ERROR_MESSAGE);
      return;
    } catch (InvalidClassException e) {
      JOptionPane.showMessageDialog(null, "Impossible de lire le corpus " + fichierCorpus.getName() +
              " : versions d'Analec incompatibles ",
              "Erreur d'ouverture de fichier .ec", JOptionPane.ERROR_MESSAGE);
      return;
    } catch (ClassCastException e) {
      JOptionPane.showMessageDialog(null, "Impossible de lire le corpus " + fichierCorpus.getName() +
              " : versions d'Analec incompatibles ",
              "Erreur d'ouverture de fichier .ec", JOptionPane.ERROR_MESSAGE);
      return;
    } catch (IOException ex) {
      corpus.fermer();
      JOptionPane.showMessageDialog(null, ex, "Erreur de lecture de fichier", JOptionPane.ERROR_MESSAGE);
      return;
    } finally {
      try {
        if (ois != null) ois.close();
      } catch (IOException ex) {
        JOptionPane.showMessageDialog(null, ex, "Erreur de fermeture de fichier lu", JOptionPane.ERROR_MESSAGE);
      }
    }
    File fichierVue = Fichiers.trouverFichier(Fichiers.Type.VUE, fichierCorpus);
    if (fichierVue == null) return;
    ouvrirVue(vue, fichierVue);
  }
  public static void ouvrirStructure(Corpus corpus) {
    File fichierStructure;
    if ((fichierStructure = Fichiers.choisirFichier(Commande.OUVRIR,
            "Choix de la structure",Fichiers.Type.STRUCTURE)) == null) return;
    ObjectInputStream ois = null;
    try {
      ois = new ObjectInputStream(new FileInputStream(fichierStructure));
      Structure structureLue = (Structure) ois.readObject();
      corpus.fusionnerStructureLue(structureLue);
    } catch (ClassNotFoundException e) {
      JOptionPane.showMessageDialog(null, "Impossible de lire la structure " + fichierStructure.getName() +
              " : versions d'Analec incompatibles ",
              "Erreur d'ouverture de fichier .ecs", JOptionPane.ERROR_MESSAGE);
      return;
    } catch (InvalidClassException e) {
      JOptionPane.showMessageDialog(null, "Impossible de lire la structure " + fichierStructure.getName() +
              " : versions d'Analec incompatibles ",
              "Erreur d'ouverture de fichier .ecs", JOptionPane.ERROR_MESSAGE);
      return;
    } catch (ClassCastException ex) {
      JOptionPane.showMessageDialog(null, "Impossible de lire la structure " + fichierStructure.getName() +
              " : versions d'Analec incompatibles ", 
              "Erreur d'ouverture de fichier .ecs", JOptionPane.ERROR_MESSAGE);
    } catch (IOException ex) {
      JOptionPane.showMessageDialog(null, ex, "Erreur de lecture de fichier", JOptionPane.ERROR_MESSAGE);
      return;
    } finally {
      try {
        if (ois != null) ois.close();
      } catch (IOException ex) {
        JOptionPane.showMessageDialog(null, ex, "Erreur de fermeture de fichier lu", JOptionPane.ERROR_MESSAGE);
      }
    }
  }
  public static void ouvrirVue(Vue vue, File fichierVue) {
    ObjectInputStream ois = null;
    try {
      ois = new ObjectInputStream(new FileInputStream(fichierVue));
      if (!vue.lireJava(ois)) {
        JOptionPane.showMessageDialog(null, "Impossible d'utiliser la vue " + fichierVue.getName() +
                " : vue incompatible avec le corpus courant", "Erreur de lecture de fichier .ecv", JOptionPane.ERROR_MESSAGE);
        if (ois != null) ois.close();
        return;
      }
    } catch (InvalidClassException ex) {
      JOptionPane.showMessageDialog(null, "Impossible de lire la vue " + fichierVue.getName() +
              " : versions d'Analec incompatibles ", "Erreur d'ouverture de fichier .ecv", JOptionPane.ERROR_MESSAGE);
      return;
    } catch (IOException ex) {
      JOptionPane.showMessageDialog(null, ex, "Erreur de lecture de fichier", JOptionPane.ERROR_MESSAGE);
      return;
    } catch (ClassNotFoundException ex) {
      JOptionPane.showMessageDialog(null, "Impossible de lire la vue " + fichierVue.getName() +
              " : versions d'Analec incompatibles ", "Erreur d'ouverture de fichier .ecv", JOptionPane.ERROR_MESSAGE);
      return;
    } catch (ClassCastException ex) {
      JOptionPane.showMessageDialog(null, "Impossible de lire la vue " + fichierVue.getName() +
              " : versions d'Analec incompatibles ", "Erreur d'ouverture de fichier .ecv", JOptionPane.ERROR_MESSAGE);
      return;
    } finally {
      try {
        if (ois != null) ois.close();
      } catch (IOException ex) {
        JOptionPane.showMessageDialog(null, ex, "Erreur de fermeture de fichier lu", JOptionPane.ERROR_MESSAGE);
      }
    }
  }
  public static void ouvrirVue(Vue vue) {
    File fichierVue;
    if ((fichierVue = Fichiers.choisirFichier(Commande.OUVRIR,
            "Choix de la vue", Fichiers.Type.VUE)) == null) return;
    ouvrirVue(vue, fichierVue);
  }
  public static void fusionnerAnnot(Corpus corpus) {
    File fichierCorpus;
    if ((fichierCorpus = Fichiers.choisirFichier(Commande.OUVRIR,
            "Choix du fichier à fusionner", Fichiers.Type.CORPUS)) == null) return;
    ObjectInputStream ois = null;
    try {
      ois = new ObjectInputStream(new FileInputStream(fichierCorpus));
      corpus.fusionnerAnnotJava(ois);
    } catch (ClassNotFoundException e) {
      JOptionPane.showMessageDialog(null, "Impossible de lire le corpus " + fichierCorpus.getName() +
              " : versions d'Analec incompatibles ",
              "Erreur d'ouverture de fichier .ec", JOptionPane.ERROR_MESSAGE);
      return;
    } catch (ClassCastException e) {
      JOptionPane.showMessageDialog(null, "Impossible de lire le corpus " + fichierCorpus.getName() +
              " : versions d'Analec incompatibles ",
              "Erreur d'ouverture de fichier .ec", JOptionPane.ERROR_MESSAGE);
      return;
    } catch (InvalidClassException e) {
      JOptionPane.showMessageDialog(null, "Impossible de lire le corpus " + fichierCorpus.getName() +
              " : versions d'Analec incompatibles ",
              "Erreur d'ouverture de fichier .ec", JOptionPane.ERROR_MESSAGE);
      return;
    } catch (IOException ex) {
      corpus.fermer();
      JOptionPane.showMessageDialog(null, ex, "Erreur de lecture de fichier", JOptionPane.ERROR_MESSAGE);
      return;
    } finally {
      try {
        if (ois != null) ois.close();
      } catch (IOException ex) {
        JOptionPane.showMessageDialog(null, ex, "Erreur de fermeture de fichier lu", JOptionPane.ERROR_MESSAGE);
      }
    }

  }
  public static void concatenerCorpus(Corpus corpus) {
    File fichierCorpus;
    if ((fichierCorpus = Fichiers.choisirFichier(Commande.OUVRIR,
            "Choix du fichier à concaténer", Fichiers.Type.CORPUS)) == null) return;
    ObjectInputStream ois = null;
    try {
      ois = new ObjectInputStream(new FileInputStream(fichierCorpus));
      corpus.concatenerCorpusJava(ois);
    } catch (ClassNotFoundException e) {
      JOptionPane.showMessageDialog(null, "Impossible de lire le corpus " + fichierCorpus.getName() +
              " : versions d'Analec incompatibles ",
              "Erreur d'ouverture de fichier .ec", JOptionPane.ERROR_MESSAGE);
      return;
    } catch (ClassCastException e) {
      JOptionPane.showMessageDialog(null, "Impossible de lire le corpus " + fichierCorpus.getName() +
              " : versions d'Analec incompatibles ",
              "Erreur d'ouverture de fichier .ec", JOptionPane.ERROR_MESSAGE);
      return;
    } catch (InvalidClassException e) {
      JOptionPane.showMessageDialog(null, "Impossible de lire le corpus " + fichierCorpus.getName() +
              " : versions d'Analec incompatibles ",
              "Erreur d'ouverture de fichier .ec", JOptionPane.ERROR_MESSAGE);
      return;
    } catch (IOException ex) {
      corpus.fermer();
      JOptionPane.showMessageDialog(null, ex, "Erreur de lecture de fichier", JOptionPane.ERROR_MESSAGE);
      return;
    } finally {
      try {
        if (ois != null) ois.close();
      } catch (IOException ex) {
        JOptionPane.showMessageDialog(null, ex, "Erreur de fermeture de fichier lu", JOptionPane.ERROR_MESSAGE);
      }
    }
  }
  public static boolean enregistrerCorpus(Corpus corpus, File fichier) {
    if (fichier != null) return ecrireCorpus(corpus, fichier);
    else return enregistrerCorpusSous(corpus);
  }
  public static boolean enregistrerCorpusSous(Corpus corpus) {
    File fichier;
    if ((fichier = Fichiers.choisirFichier(Commande.ENREGISTRER,
            "Nom du fichier corpus", Fichiers.Type.CORPUS)) == null) return false;
    return ecrireCorpus(corpus, fichier);
  }
  public static void enregistrerStructure(Corpus corpus) {
    File fichier;
    if ((fichier = Fichiers.choisirFichier(Commande.ENREGISTRER,
            "Nom du fichier structure", Fichiers.Type.STRUCTURE)) == null) return;
    ObjectOutputStream oos = null;
    try {
      oos = new ObjectOutputStream(new FileOutputStream(fichier));
      corpus.ecrireStructureJava(oos);
    } catch (IOException ex) {
      JOptionPane.showMessageDialog(null, ex, "Erreur d'écriture de fichier", JOptionPane.ERROR_MESSAGE);
      return;
    } finally {
      try {
        if (oos != null) oos.close();
      } catch (IOException ex) {
        JOptionPane.showMessageDialog(null, ex, "Erreur de fermeture de fichier écrit", JOptionPane.ERROR_MESSAGE);
      }
    }
  }
  private static boolean ecrireCorpus(Corpus corpus, File fichier) {
    ObjectOutputStream oos = null;
    try {
      oos = new ObjectOutputStream(new FileOutputStream(fichier));
      corpus.ecrireJava(oos);
    } catch (IOException ex) {
      JOptionPane.showMessageDialog(null, ex, "Erreur d'écriture de fichier", JOptionPane.ERROR_MESSAGE);
      return false;
    } finally {
      try {
        if (oos != null) oos.close();
        return true;
      } catch (IOException ex) {
        JOptionPane.showMessageDialog(null, ex, "Erreur de fermeture de fichier écrit", JOptionPane.ERROR_MESSAGE);
        return false;
      }
    }
  }
  public static boolean enregistrerVue(Vue vue) {
    File fichier;
    if ((fichier = Fichiers.choisirFichier(Commande.ENREGISTRER,
            "Nom du fichier vue", Fichiers.Type.VUE)) == null) return false;
    ObjectOutputStream oos = null;
    try {
      oos = new ObjectOutputStream(new FileOutputStream(fichier));
      vue.ecrireJava(oos);
    } catch (IOException ex) {
      JOptionPane.showMessageDialog(null, ex, "Erreur d'écriture de fichier", JOptionPane.ERROR_MESSAGE);
      return false;
    } finally {
      try {
        if (oos != null) oos.close();
        return true;
      } catch (IOException ex) {
        JOptionPane.showMessageDialog(null, ex, "Erreur de fermeture de fichier écrit", JOptionPane.ERROR_MESSAGE);
        return false;
      }
    }
  }
}
