/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package visuAnalec.texte;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import visuAnalec.*;
import visuAnalec.elements.*;
import visuAnalec.util.*;
import visuAnalec.vue.*;

/**
 *
 * @author Bernard
 */
public class PanneauOccurrences extends JTable implements ListSelectionListener {
  ModeleTableauOcc modele;
  PanneauEditeur pEditeur;
  public PanneauOccurrences(Vue vue, PanneauEditeur pEditeur) {
    super();
    modele = new ModeleTableauOcc(vue);
    setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
    setModel(modele);
    getSelectionModel().addListSelectionListener(this);
    this.pEditeur = pEditeur;
  }
  public void init(Element[] listElt) {
    getTableHeader().setVisible(listElt.length > 0);
    modele.setModele(listElt);
    getColumnModel().getColumn(0).setPreferredWidth(150);
    getColumnModel().getColumn(1).setMinWidth(1200);
  }
  @Override
  public void valueChanged(ListSelectionEvent evt) {
    try {
      if (evt.getValueIsAdjusting()) return;
      if (evt.getSource().equals(getSelectionModel())) {
        int row = getSelectedRow();
        if (row >= 0) pEditeur.editerElement(modele.getElement(row));
        return;
      }
      throw new UnsupportedOperationException("Evénement non prévu : " + evt.toString());
    } catch (Throwable ex) {
      GMessages.erreurFatale(ex);
    }
  }

  private static class ModeleTableauOcc extends AbstractTableModel {
    Element[] listeElt;
    Vue vue;
    final static int EMPAN = 80;  // paramètre à saisir (un jour)
    final static String STYLE_HTML = "<html>";
    final static String STYLE_DEB_SELECT =
            "<span style=\"font-weight:bold; background-color:#FFFF80\">";
    final static String STYLE_FIN_SELECT = "</span>";
    String[] extraits;
    public ModeleTableauOcc(Vue vue) {
      super();
      this.vue = vue;
      setModele(new Element[0]);
    }
    public int getRowCount() {
      return listeElt.length;
    }
    public int getColumnCount() {
      return 2;
    }
    @Override
    public String getColumnName(int columnIndex) {
      return columnIndex == 0 ? "Identifiants" : "Occurrences";
    }
    public Object getValueAt(int rowIndex, int columnIndex) {
      if (columnIndex == 0) return vue.getIdElement(listeElt[rowIndex]);
      return extraits[rowIndex];

    }
    private Element getElement(int selectedRow) {
      return listeElt[selectedRow];
    }
    private void setModele(Element[] elts) {
      listeElt = elts;
      extraits = new String[elts.length];
      for (int i = 0; i < elts.length; i++) extraits[i] = calculeExtrait(elts[i],
                vue.getCorpus().getTexte(), vue.getCorpus().getFinParagraphes());
      fireTableDataChanged();
    }
    private String calculeExtrait(Element elt, String texte, Integer[] finPar) { // à mettre ailleurs ??
      Unite unite0 = elt.getUnite0();
      String extrait = STYLE_HTML;
      int debElt = unite0.getDeb();
      int finElt = unite0.getFin();
      int deb, fin;
      if ((deb = debElt - EMPAN) > 0) extrait += "[...]";
      else deb = 0;
      extrait += PanneauTexte.insereCarFinParagraphe(texte.substring(deb, debElt), finPar, deb);
      extrait += STYLE_DEB_SELECT;
      extrait += PanneauTexte.insereCarFinParagraphe(texte.substring(debElt, finElt), finPar, debElt);
      extrait += STYLE_FIN_SELECT;
      if ((fin = finElt + EMPAN) < texte.length())
        extrait += PanneauTexte.insereCarFinParagraphe(texte.substring(finElt, fin), finPar, finElt) + "[...]";
      else
        extrait += PanneauTexte.insereCarFinParagraphe(texte.substring(finElt), finPar, finElt);
      return extrait;
    }
  }
}
